require 'helper'

=begin
  Signatures in tests generated by existing PHP signatory, to ensure
  compatibility.

  http://github.com/matchu/openneo-auth-server/blob/master/openneo_auth_signatory.class.php
=end

class TestOpenneoAuthSignatory < Test::Unit::TestCase
  def setup
    @signatory = Openneo::Auth::Signatory.new('MySecret32!!')
  end
  
  def test_sign
    assert_signature(
      '405f4c596ae21770ca6a304ff34f45e11c496fb7bc1d23abb58663719e061fb3',
      :foo => 'bar', :eggs => 'spam', :your => 'mom'
    )
  end
  
  def test_multiple_signatures
    assert_signature(
      'a21492375b22c4155f5c374b98de16c151ba3d721d86325c97f3f27741a0b7a2',
      :foo => 'bar'
    )
    assert_signature(
      'f2eff505366cc77f64204e5fcdc3fb58d0ac0aa442f6e58837de0fab3a121d1d',
      :bart => 'foot'
    )
  end
  
  def test_order_insensitive
    signature = '3e105d0690d99e3c9046b393e9bc338301a69d710756a5a5cfc3872b1ca7bb36'
    assert_signature signature, :a => 1, :b => 2, :c => 3
    assert_signature signature, :c => 3, :b => 2, :a => 1
  end
  
  def test_nested_hash
    assert_signature(
      '8aa5f3b84750d0f8b67e1f9cc30010906457f576b22a82d6f5408c60fa9ede57',
      :hello => 'world', :foo => {:bar => 1, :baz => 2}
    )
  end
end
